local addonName, ns = ...
ns[1] = {}			-- B, Basement
ns[2] = {}			-- C, Config
ns[3] = {}			-- L, Locales
ns[4] = {}			-- DB, Database

if IsAddOnLoaded("NDui") then
	ns[1], ns[2], ns[3], ns[4] = unpack(NDui)
end

NDuiPlusDB = {}

local B, C, L, DB = unpack(ns)
local P = B:RegisterModule("Plus")

local pairs, type = pairs, type

local Media = "Interface\\Addons\\NDui_Plus\\Media\\"

local defaultSettings = {
	["debug"] = false,
	["Loot"] = true,
	["LootAnnounce"] = true,
	["LootAnnounceTitle"] = true,
	["LootAnnounceRarity"] = 1,
	["normTex"] = false,
	["InboxMailBag"] = true,
	["MerInspect"] = true,
	["alaGearMan"] = true,
	["ClassicThreatMeter"] = true,
	["Spy"] = true,
	["ButtonForge"] = true,
	["ChatEmote"] = false,
	["MeetingHorn"] = false,
	["Ace3"] = true,
	["GearMenu"] = true,
	["LootRoll"] = false,
	["LootRollWidth"] = 328,
	["LootRollHeight"] = 28,
	["LootRollDirection"] = 2,
	["alaCalendar"] = true,
	["ls_Toasts"] = true,
	["WIM"] = true,
	["ItemRack"] = true,
	["WhisperPop"] = true,
	["AutoBarClassic"] = true,
}

local loader = CreateFrame("Frame")
loader:RegisterEvent("ADDON_LOADED")
loader:SetScript("OnEvent", function(self, _, addon)
	if addon ~= "NDui_Plus" then return end

	for key in pairs(NDuiPlusDB) do
		if defaultSettings[key] == nil then
			NDuiPlusDB[key] = nil
		end
	end

	for key, value in pairs(defaultSettings) do
		if NDuiPlusDB[key] == nil then
			if type(value) == "table" then
				NDuiPlusDB[key] = {}
				for k in pairs(value) do
					NDuiPlusDB[key][k] = value[k]
				end
			else
				NDuiPlusDB[key] = value
			end
		end
	end

	if NDuiPlusDB["normTex"] then DB.normTex = Media.."normTex" end

	self:UnregisterAllEvents()
end)

function P:Debug(...)
	if NDuiPlusDB["debug"] then
		_G.DEFAULT_CHAT_FRAME:AddMessage("|cFF70B8FFNDui_Plus:|r " .. format(...))
	end
end

function P:Print(...)
	_G.DEFAULT_CHAT_FRAME:AddMessage("|cFF70B8FFNDui_Plus:|r " .. format(...))
end

function P:VersionCheck_Compare(new, old)
	local new1, new2, new3 = strsplit(".", new)
	new1, new2, new3 = tonumber(new1), tonumber(new2), tonumber(new3)

	local old1, old2, old3 = strsplit(".", old)
	old1, old2, old3 = tonumber(old1), tonumber(old2), tonumber(old3)

	if new1 > old1 or (new1 == old1 and new2 > old2) or (new1 == old1 and new2 == old2 and new3 > old3) then
		return "IsNew"
	elseif new1 < old1 or (new1 == old1 and new2 < old2) or (new1 == old1 and new2 == old2 and new3 < old3) then
		return "IsOld"
	end
end

function P:OnLogin()
	local status = self:VersionCheck_Compare(DB.Version, "1.20.0")
	if status == "IsOld" then
		self:Print(L["Version Check"])
		return
	end

	self:Skins()
	self:LootEx()
	self:ChatEmote()
	self:Misc()
	self:LootRoll()
end
