local _, ns = ...
local B, C, L, DB = unpack(ns)
local P = B:GetModule("Plus")

local _G = getfenv(0)
local select, pairs, type = select, pairs, type

local r, g, b = DB.r, DB.g, DB.b

local function expandOnEnter(self)
	if self:IsEnabled() then
		self.bg:SetBackdropColor(r, g, b, .25)
	end
end

local function expandOnLeave(self)
	self.bg:SetBackdropColor(0, 0, 0, .25)
end

local function SetupTexture(self, texture)
	if self.settingTexture then return end
	self.settingTexture = true
	self:SetNormalTexture("")

	if texture and texture ~= "" then
		if type(texture) == "number" then
			if texture == 130838 then
				self.expTex:SetTexCoord(0, .4375, 0, .4375)
			elseif texture == 130821 then
				self.expTex:SetTexCoord(.5625, 1, 0, .4375)
			end
		else
			if texture:find("Plus") then
				self.expTex:SetTexCoord(0, .4375, 0, .4375)
			elseif texture:find("Minus") then
				self.expTex:SetTexCoord(.5625, 1, 0, .4375)
			end
		end
		self.bg:Show()
	else
		self.bg:Hide()
	end
	self.settingTexture = nil
end

function P:ReskinExpandOrCollapse()
	self:SetHighlightTexture("")
	self:SetPushedTexture("")

	local bg = B.CreateBDFrame(self, .25)
	bg:ClearAllPoints()
	bg:SetSize(13, 13)
	bg:SetPoint("TOPLEFT", self:GetNormalTexture())
	B.CreateGradient(bg)
	self.bg = bg

	self.expTex = bg:CreateTexture(nil, "OVERLAY")
	self.expTex:SetSize(7, 7)
	self.expTex:SetPoint("CENTER")
	self.expTex:SetTexture("Interface\\Buttons\\UI-PlusMinus-Buttons")

	self:HookScript("OnEnter", expandOnEnter)
	self:HookScript("OnLeave", expandOnLeave)
	hooksecurefunc(self, "SetNormalTexture", SetupTexture)
end

local function TexSetupTexture(self, texture)
	local frame = self:GetParent()
	if self.settingTexture then return end
	self.settingTexture = true
	self:SetTexture("")

	if texture and texture ~= "" then
		if type(texture) == "number" then
			if texture == 130838 then
				frame.expTex:SetTexCoord(0, .4375, 0, .4375)
			elseif texture == 130821 then
				frame.expTex:SetTexCoord(.5625, 1, 0, .4375)
			end
		else
			if texture:find("plus") then
				frame.expTex:SetTexCoord(0, .4375, 0, .4375)
			elseif texture:find("minus") then
				frame.expTex:SetTexCoord(.5625, 1, 0, .4375)
			end
		end
		frame.bg:Show()
	else
		frame.bg:Hide()
	end
	self.settingTexture = nil
end

function P:ReskinExpandOrCollapseTex()
	self:SetTexture("")
	local frame = self:GetParent()

	local bg = B.CreateBDFrame(frame, .25)
	bg:ClearAllPoints()
	bg:SetSize(13, 13)
	bg:SetPoint("TOPLEFT", frame)
	B.CreateGradient(bg)
	frame.bg = bg

	frame.expTex = bg:CreateTexture(nil, "OVERLAY")
	frame.expTex:SetSize(7, 7)
	frame.expTex:SetPoint("CENTER")
	frame.expTex:SetTexture("Interface\\Buttons\\UI-PlusMinus-Buttons")

	frame:HookScript("OnEnter", expandOnEnter)
	frame:HookScript("OnLeave", expandOnLeave)
	hooksecurefunc(self, "SetTexture", TexSetupTexture)
	hooksecurefunc(self, "Show", function()
		self:GetParent().bg:Show()
		self:GetParent().expTex:Show()
	end)
	hooksecurefunc(self, "Hide", function()
		self:GetParent().bg:Hide()
		self:GetParent().expTex:Hide()
	end)
end

function P.ReskinFont(font, size)
	local oldSize = select(2, font:GetFont())
	size = size or oldSize
	local fontSize = size*NDuiDB["Skins"]["FontScale"]
	font:SetFont(DB.Font[1], fontSize, DB.Font[3])
	font:SetShadowColor(0, 0, 0, 0)
end